/**
 *  Klasse, die die Differenz zwischen zwei Daten in Tagen berechnet
 *  DateDifferenceInDays.java  Version 1.2
 *  Copyright (C) 2000, 2001 Frank Gehde
 *
 *  Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General
 *  Public License wie sie von der Free Software Foundation in der Version zwei oder(wenn 
 *  Sie wollen) in einer spteren Version verffentlicht wurde. Die Version 2 ist diesem 
 *  Programm als Datei 'license.txt' beigefgt. Wenn Sie das 'Programm' weitergeben, men 
 *  die license.txt und die readme.txt mit weitergegeben werden.
 *
 *  Das Programm wird in der Hoffnung, da es ntzlich ist weitergegeben, aber OHNE JEDE 
 *  GARANTIE; insbesondere ohne implizite Garantie der Verwendbarkeit fr irgendeinen 
 *  bestimmten Zweck. Bitte lesen Sie die GNU General Public License fr mehr Details 
 *  (beigefgte Datei license.txt).
 *
 *  Sollte aus irgendwelchen Grnden die Lizenz fehlen, schreiben Sie bitte an die 
 *  Free Software Foundation, Inc., 
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 *  Auftretende Fehler, Verbesserungen oder Vorschlge freundlicherweise per eMail an:   
 *  gehde@ag-intra.net
 */

import java.util.*;

public class DateDifferenceInDays {
	// ******** Attribute Anfang
	private Calendar earlyDate = new GregorianCalendar();	// Attribute fr diese Klasse 
	private Calendar laterDate = new GregorianCalendar();
	private int difference;
	// ******** Attribute Ende

	// ******** Konstruktoren Anfang
	public DateDifferenceInDays() {				// Konstruktor 1 fr diese Klasse 
		earlyDate.setTime(new Date());			// setzt beide Daten auf HEUTE
		laterDate.setTime(new Date());
	}
	
	public DateDifferenceInDays(int earlyDay, int earlyMonth, int earlyYear) { // Konstruktor 2
		earlyDate.set(earlyYear, earlyMonth, earlyDay);	// setzt early auf Parameter und
		laterDate.setTime(new Date());			// late auf HEUTE.
		if(laterDate.before(earlyDate)) toggeleDates(); //Daten vertauschen
	}

	public DateDifferenceInDays(int earlyDay, int earlyMonth, int earlyYear,
				    int laterDay, int laterMonth, int laterYear) { // Konstruktor 3

		earlyDate.set(earlyYear, earlyMonth, earlyDay);	// setzt early auf Parameter und
		laterDate.set(laterYear, laterMonth, laterDay);	// late auf Parameter. 
		if(laterDate.before(earlyDate)) toggeleDates(); //Daten vertauschen
	}							
	// ******** Konstruktoren Ende

	// ******** Methoden Anfang
	public void setEarly(int earlyDay, int earlyMonth, int earlyYear) { // Early Datum setzen
		earlyDate.set(earlyYear, earlyMonth, earlyDay);
		if(laterDate.before(earlyDate)) toggeleDates(); //Daten vertauschen
	}
	public void setLater(int laterDay, int laterMonth, int laterYear) { // Later Datum setzen
		laterDate.set(laterYear, laterMonth, laterDay);
		if(laterDate.before(earlyDate)) toggeleDates(); //Daten vertauschen
	}

	private void compute() {			// Differenz in Tagen berechnen
                difference = 0;  
                                           
                while(earlyDate.before(laterDate)) {
			earlyDate.add(Calendar.DATE, 1);
			difference++;
		}
	}

	private void toggeleDates() {
		Calendar tempDate = new GregorianCalendar();	// Vertauscht Early und
		tempDate.set(earlyDate.get(Calendar.YEAR),	// Later Date
			     earlyDate.get(Calendar.MONTH),
			     earlyDate.get(Calendar.DATE));
		earlyDate.set(laterDate.get(Calendar.YEAR),
			     laterDate.get(Calendar.MONTH),
			     laterDate.get(Calendar.DATE));
		laterDate.set(tempDate.get(Calendar.YEAR),
			     tempDate.get(Calendar.MONTH),
			     tempDate.get(Calendar.DATE));
	}
	
	public int getEarlyDay() {			// Tag von Early zurckgeben
		return earlyDate.get(Calendar.DATE);
	}
	public int getEarlyMonth() {			// Monat von Early zurckgeben
		return earlyDate.get(Calendar.MONTH);
	}
	public int getEarlyYear() {			// Jahr von Early zurckgeben
		return earlyDate.get(Calendar.YEAR);
	}

	public int getLaterDay() {			// Tag von Later zurckgeben
		return laterDate.get(Calendar.DATE);
	}
	public int getLaterMonth() {			// Monat von Later zurckgeben
		return laterDate.get(Calendar.MONTH);
	}
	public int getLaterYear() {			// Jahr von Later zurckgeben
		return laterDate.get(Calendar.YEAR);
	}

	public int getDifference() {   			//Die Methode zum Abfragen der Differenz
		this.compute();
		return difference; 
	} // ******** Methoden Ende
}